##############################################################################
# ScoDoc
# Copyright (c) 1999 - 2023 Emmanuel Viennet.  All rights reserved.
# See LICENSE
##############################################################################

"""Feuille d'export Jury BUT
"""
import datetime

from flask import render_template, url_for

import app
from app import Departement
from app.models import FormSemestre, FormSemestreInscription
from app.views import ScoData


def feuille_preparation_jury_but(formsemestre_id: int):
    formsemestre: FormSemestre = FormSemestre.query.filter_by(
        id=formsemestre_id
    ).first_or_404()
    departement: Departement = Departement.query.filter_by(
        id=formsemestre.dept_id
    ).first_or_404()
    return render_template(
        "but/jury_export.j2",
        datetime=datetime,
        formsemestre=formsemestre,
        dept=departement.acronym,
        sco=ScoData(formsemestre=formsemestre),
    )
